
#include "Arduino.h"

#define ENABLE 10

uint32_t icr;
float period_pwm;
uint16_t diviseur[6] = {0,1,8,64,256,1024};
                
void init_pwm_timer1_fixe(float period, float ratio) { // rapport cyclique fixe, period en 1/100 us
      char clockBits;
    TCCR1A = 0;
    TCCR1A |= (1 << COM1A1); //Clear OCnA/OCnB/OCnC on compare match, set OCnA/OCnB/OCnC at BOTTOM (non-inverting mode)
    TCCR1A |= (1 << COM1B1);
#if defined(__AVR_ATmega2560__) || defined(__AVR_ATmega32U4__)
    TCCR1A |= (1 << COM1C1);
#endif
    TCCR1B = 1 << WGM13; // phase and frequency correct pwm mode, top = ICR1
    int d = 1;
    icr = (F_CPU/1000000*period/2);
    while ((icr>0xFFFF)&&(d<6)) { // choix du diviseur d'horloge
        d++;
        icr = (F_CPU/1000000*period/2/diviseur[d]);
   } 
   clockBits = d;
   ICR1 = icr; // valeur maximale du compteur
   OCR1A = ratio*icr;
   TCNT1 = 0; // mise à zéro du compteur
   TCCR1B |= clockBits; // déclenchement du compteur
}
                  
void setup() {
  Serial.begin(115200);
  pinMode(ENABLE,OUTPUT);
  digitalWrite(ENABLE,LOW);
  
#if defined(__AVR_ATmega2560__)
    pinMode(11,OUTPUT); // sortie PWM pour MEGA
#else
    pinMode(9,OUTPUT); // sortie PWM pour UNO
#endif
    period_pwm = 31.0; // en microsecondes
    init_pwm_timer1_fixe(period_pwm,0.5);
    digitalWrite(ENABLE,HIGH);
}
                   
void loop() {
    
}
                     